

// page 92
 /*
 The external oscillator module can be configured in one
 of the following clock modes, by setting the
 FEXTOSC<2:0> Configuration bits:
 1. ECL – External Clock Low-Power mode
 2. ECM – External Clock Medium Power mode
 3. ECH – External Clock High-Power mode
 4. LP – 32 kHz Low-Power Crystal mode.
 5. XT – Medium Gain Crystal or Ceramic Resonator Oscillator mode (between 100 kHz and 8 MHz)
 6. HS – High Gain Crystal or Ceramic Resonatorm ode (above 4 MHz)
 The ECH, ECM, and ECL Clock modes rely on an external logic level signal as the device clock source.
 The LP, XT, and HS Clock modes require an external crystal or resonator to be connected to the device.
 Each mode is optimized for a different frequency range.
 -----
 7.2.2 INTERNAL CLOCK SOURCES  page  97
 The internal oscillator block produces low and high
 clock sources, designated LFINTOSC and HFINTOSC. (see Internal Oscillator Block, Figure 7-1).
 Multiple device clock frequencies may be derived from these clock sources.
 The internal oscillator block has two internal oscillators that are used to generate internal
system clock sources. 
The High-Frequency Internal Oscillator (HFINTOSC) can produce 1, 2, 4, 8, 12, 16,32, 48 and 64 MHz clock. The frequency can be
controlled through the OSCFRQ register (Register 7-5). 
The Low-Frequency Internal Oscillator (LFINTOSC)generates a fixed 31 kHz frequency.
A 4x PLL is provided that can be used with an external clock. 
When used with the HFINTOSC the 4x PLL hasi nput frequency limitations.See Section 7.2.1.4 “4x PLL” for more details.
The system clock can be selected between external or internal clock sources via the NOSC bits in the
OSCCON1 register. See Section 7.3 “Clock
Switching” for additional information. 
The systemc lock can be made available on the OSC2/CLKOUT pin
for any of the modes that do not use the OSC2 pin. 
Theclock out functionality is governed by the CLKOUTENb it in the CONFIG1H register (Register 5-2). 
If enabled,t he clock out signal is always at a frequency of FOSC/4.
*/

    // REGISTER 7-6: OSCTUNE: HFINTOSC TUNING REGISTER
    OSCTUNE=0x00;
    //REGISTER 7-7: OSCEN: OSCILLATOR MANUAL ENABLE REGISTER
    OSCEN=0;
     //OSCCON2   Clock Source type  = HF INTOSC
     COSC2_bit=1;
     COSC1_bit=1;
     COSC0_bit=0;
    // clock diviser =1
     CDIV3_bit=0;
     CDIV2_bit=0;
     CDIV1_bit=0;
     CDIV0_bit=0;
     //REGISTER 8-1: CLKRCON: REFERENCE CLOCK CONTROL REGISTER
      CLKRCON.B7 =1;  // EN=1 = Reference clock module enabled
       //DC<1:0>: Reference Clock Duty Cycle bits 50%
      CLKRCON.B4 =1; //DC1=1;
      CLKRCON.B3=0; // DC2=0;
     //DIV<2:0>: Reference Clock Divider bits
      CLKRCON.B2=1;
      CLKRCON.B1=0;
      CLKRCON.B0=0;
      // REGISTER 7-5: OSCFRQ: HFINTOSC FREQUENCY SELECTION REGISTER
   // Frequence selection 64MHz
     FRQ3_bit=1   ;
     FRQ2_bit=0   ;
     FRQ1_bit=0   ;
     FRQ0_bit=0   ;
     // 48 MhZ ?
     //FRQ3_bit=0   ;
    // FRQ2_bit=1   ;
    // FRQ1_bit=1   ;
    // FRQ0_bit=1   ;
  
     // 32 MhZ ?
     //FRQ3_bit=0   ;
     //FRQ2_bit=1   ;
     //FRQ1_bit=1   ;
     //FRQ0_bit=0   ;
     
      // 16 MhZ ?
    // FRQ3_bit=0   ;
    // FRQ2_bit=1   ;
    // FRQ1_bit=0   ;
    // FRQ0_bit=1   ;
     
  //  REGISTER 7-7: OSCEN: OSCILLATOR MANUAL ENABLE REGISTER
  //  R/W-0/0 R/W-0/0 R/W-0/0 R/W-0/0 R/W-0/0 R/W-0/0 U-0 U-0
  //  EXTOEN HFOEN MFOEN LFOEN SOSCEN ADOEN — —
    OSCEN=0;
    OSCEN.HFOEN=1;

   //-----------------------------
    //  8.0 REFERENCE CLOCK OUTPUT MODULE     p 113
    // REGISTER 8-1: CLKRCON: REFERENCE CLOCK CONTROL REGISTER
    // REGISTER 8-2: CLKRCLK: CLOCK REFERENCE CLOCK SELECTION MUX
    // U-0 U-0 U-0 U-0 R/W-0/0 R/W-0/0 R/
    //CLK<7:4>:  unused=0
    //CLK<3:0>: CLKR Clock Selection bits
    //0001 = HFINTOSC
      CLKREN_bit=1;
      //Reference Clock Duty Cycle 50%
      CLKRDC1_bit=1;   CLKRDC0_bit=0;
      //Reference Clock Divider bits   Base clock value divided by 16
      CLKRDIV2_bit=1;  CLKRDIV1_bit=0; CLKRDIV0_bit=0;
  
   // 8.5 Register Definitions: Reference Clock
   // Long bit name prefixes 
   //  for the Reference Clock peripherals are shown below.
   //  Refer to Section 1.3.2.2 “Long Bit Names” for more information.
    //REGISTER 8-1: CLKRCON: REFERENCE CLOCK CONTROL REGISTER
    //R/W-0/0 U-0 U-0 R/W-1/1 R/W-0/0 R/W-0/0 R/W-0/0 R/W-0/0
    //EN — — DC<1:0> DIV<2:0>
    CLKRCLK3_bit=0;
    CLKRCLK2_bit=0;
    CLKRCLK1_bit=0;
    CLKRCLK0_bit=0;
